#!/usr/bin/perl
#
# dynindex.cgi
#
# 2001-6-2 manchek
#
# dynamically generate html for albums index
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};

$debug=0;

## ixbkt
#
# get the index bucket tag for a string
#
sub ixbkt {
   my ($a) = @_;
   $a = substr($a, 0, 1);
   if ($a ge "A" && $a le "Z") {
	return $a;
   } elsif ($a ge "a" && $a le "z") {
	return uc($a);
   } else {
	return "A";
   }
}

Tunebot::suckInCookies;
$tunebot_user=$cookie{TUNEBOTUSER};

#
# spit out html top boilerplate
#
Tunebot::printPageHeader "Tunes by Artist";

Tunebot::suckInPostGet;

Tunebot::suckInTags();
Tunebot::suckInAutotags();

print "<center><font size=+2>Tunes by Artist </font>\n";
print "<br>click to make a request</center>\n";
if ($posts{"abn"} ne "") {
    $albnum=$posts{"abn"};
    $quicklinks="<p><center>".Tunebot::renderQuickLinks()."</center>\n";
    print $quicklinks;
    $n=$configs{INDEX_ALBUMS};
    if ($n < 1 || $n > 1000) {
	$n=20;
    }
    renderAlbums($albnum, $n);
    print $quicklinks;
}

#
# html bottom boilerplate
#
Tunebot::printPageTrailer;
exit 0;

sub renderAlbums {
    $albnum=$_[0];
    $trknum=$autotags{$autotags{"IXA/AB/$albnum", "PATH"}, "IXA_FTA"};
    $count = $_[1];
    $indent = 0;
    $lastar = "";
    $lastal = "";
    $lastalf = substr($cb, 0, 1);

    $lastalf = chr(ord($lastalf) - 1);

    if ($albnum > 1) {
	$previouspage = $albnum - $count;
	if ($previouspage < 1) {
	    $previouspage = 1;
	}
    } else {
	$previouspage = 0;
    }
    if ($albnum + $count <= $autotags{"IXA", "NAB"}) {
	$nextpage = $albnum + $count;
    } else {
	$nextpage = 0;
    }

    $navimage=1;
    if ($navimage) {
	print "<map name=\"navmap\">\n";
	print " <area href=\"$cgibinurl/artists.cgi\" alt=\"To index\" shape=poly coords=\"25,19,38,18,48,26,48,37,39,47,25,46,15,41,15,32\">\n";
	print " <area href=\"#TOPOFILE\" alt=\"Top of page\" shape=poly coords=\"17,1,45,1,38,18,25,18\">\n";
	print " <area href=\"#ENDOFILE\" alt=\"Bottom of page\" shape=poly coords=\"18,64,46,64,39,47,26,47\">\n";
	print " <area href=\"$cgibinurl/tuneq.cgi\" alt=\"Whuzzon\" shape=poly coords=\"64,1,48,1,40,18,49,31,64,31\">\n";
	if ($previouspage > 0) {
	    if ($configs{AVOID_ANCHORS}) {
		print " <area href=\"$cgibinurl/dynindex.cgi?abn=$previouspage\" alt=\"Previous page\" shape=poly coords=\"1,1,16,1,24,18,15,31,1,31\">\n";
	    } else {
		print " <area href=\"$cgibinurl/dynindex.cgi?abn=$previouspage#ENDOFILE\" alt=\"Previous page\" shape=poly coords=\"1,1,16,1,24,18,15,31,1,31\">\n";
	    }
	}
	if ($nextpage > 0) {
	    print " <area href=\"$cgibinurl/dynindex.cgi?abn=$nextpage\" alt=\"Next page\" shape=poly coords=\"39,47,49,37,64,37,64,64,46,64\">\n";
	}
	print "</map>\n";

	if ($previouspage > 0) {
	    if ($nextpage > 0) {
		$navblot = "nav_pn.gif";
	} else {
		$navblot = "nav_p.gif";
	    }
	} else {
	    if ($nextpage > 0) {
		$navblot = "nav_n.gif";
	    } else {
		$navblot = "nav.gif";
	    }
	}
    }

    ++$count;
    TRACK: while ($count > 0) {
	$path=$autotags{"IXA/TK/$trknum", "PATH"};
	last TRACK if ($path eq "");

	@raw = split('/', $path);
	$n = $#raw;
	$artistfile = join("/", @raw[0..$n-2]);
	$artist = $tags{$artistfile, "N"};
	if ($artist eq "") {
	    $artist = $raw[$n-2];
	}
	$sartist = $tags{$artistfile, "SORT"};
	if ($sartist eq "") {
	    $sartist = $artist;
	    $sartist =~ tr/a-z/A-Z/;
	}
	$albumfile = join("/", @raw[0..$n-1]);
	$album = $tags{$albumfile, "N"};
	if ($album eq "") {
	    $album = $raw[$n-1];
	}
	$track = $tags{$path, "N"};
	if ($track eq "") {
	    $track = $raw[$n];
	}
	if ($tags{$path, "ARTIST"} ne "") {
	    $track = $track . "<em> - " . $tags{$path, "ARTIST"} . "</em>";
	}
#	@aat = split('/', $render{$sartist});
	$i = 2;
	if ($artist ne $lastar) {
	    $i = 0;
	} elsif ($album ne $lastal) {
	    $i = 1;
	}
	if ($i != 2) {
	    --$count;
	    last TRACK if ($count < 1);
	}
	$lastar = $artist;
	$lastal = $album;
#print "<br> $i $path $artist $album $track \n";

	while ($indent > $i) {
	    if ($indent == 2) {
#		print "</table></td><td align=center>X</td></tr></table>\n"
		if ($albumicon ne "") {
		    print "</table></td><td align=center><img src=\"$albumicon\"></td></tr></table>\n"
		} else {
		    print "</table></td><td align=center> &nbsp; </td></tr></table>\n"
		}
	    }
	    if ($indent == 1) {
		print "</ul>\n"
	    }
	    $indent--;
	}
	$i = 2;
	while ($indent < $i) {
	    $t = 1;
	    $indent++;
	    if ($indent == 1) {
		while ($lastalf lt ixbkt($sartist)) {
		    $lastalf = chr(ord($lastalf) + 1);
#		    print "<a name=\"", $lastalf, "\">\n";
		}
#		print "<a name=\"", $artist, "\">\n";
		print "<table width=50%>\n";
		$faa = $autotags{$artistfile, "IXA_FAA"};
		print "<tr><td align=left><p><font size=+2><a href=\"$cgibinurl/
dynindex.cgi?abn=$faa\">$artist</a></font></td>\n";
		print "<td align=right>\n";
		if ($navimage) {
		    print "<img src=\"$topurl/$navblot\" border=0 usemap=\"#navmap\">\n";
		} else {
		    print "<table>\n";
		    print "<tr><td colspan=3 align=center><a href=\"#TOPOFILE\">\n";
		    print "<img src=\"$topurl/upto.gif\" alt=\"topOfPage\" border=0></a></td></tr>\n";
		    print "<tr><td align=center>";
		    if ($previouspage > 0) {
			print "<a href=\"$cgibinurl/dynindex.cgi?abn=$previouspage#ENDOFILE\"><img src=\"$topurl/upup.gif\" alt=\"previousPage\" border=0></a>\n";
		    }
		    print "</td>\n";
		    print "<td align=center><a href=\"$cgibinurl/artists.cgi\"><img src=\"$topurl/ana.gif\" alt=\"to Index\" border=0></a></td>\n";
		    print "<td align=center>";
		    if ($nextpage > 0) {
			print "<a href=\"$cgibinurl/dynindex.cgi?abn=$nextpage\"><img src=\"$topurl/downdown.gif\" alt=\"nextPage\" border=0></a>\n";
		    }
		    print "</td></tr>\n";
		    print "<tr><td colspan=3 align=center><a href=\"#ENDOFILE\">\n";
		    print "<img src=\"$topurl/downto.gif\" alt=\"bottomOfPage\" border=0></a></td></tr>\n";
		    print "</table>\n";
		}

		print "</td>\n";
		print "</tr>\n";
		print "</table>\n";
		print "<ul>\n";
	    } elsif ($indent == 2) {
#		print "<a name=\"", $artist, "/", $album, "\">\n";
		print "<li><b> $album </b>\n";
		print "<a href=\"$cgibinurl/tuneput.cgi?album=" . $albumfile . "\"><img border=0 align=middle alt=\"Play\" src=\"$topurl/play.gif\"></a>\n";
		print "<a href=\"$cgibinurl/playalbum.cgi?album=" . $albumfile . "\"><img border=0 align=middle alt=\"Play Selected Tracks\" src=\"$topurl/playoption.gif\"></a>\n";
		if ($tags{$albumfile, "DATE"} ne "") {
		    print "<br><em>" . $tags{$albumfile, "DATE"} . "</em>\n";
		}
#		print "<table width=50% cellpadding=0>\n";
		print "<table width=90% cellpadding=0>\n";
		print "<tr><td width=60%>\n";
		print "<table width=100% cellpadding=0>\n";
		if ($tags{$albumfile, "ICON"} ne "") {
		    $albumicon=$albumfile . "/" . $tags{$albumfile, "ICON"};
		    $albumicon =~ s/^\///;
		    $albumicon =~ s/\//./g;
		    $albumicon="$topurl/icons/". $albumicon;
		} else {
		    $albumicon="";
		}
	    }
	}
	$ttime = $tags{$path, "T"};
	if ($ttime eq "") {
	    $ttime = "(?)";
	}
	print "<tr>";
	print "<td align=right><font size=-1>$t.</font> <a href=\"$cgibinurl/tuneput.cgi?$path.mp3\">$track</a></td>";
	$t++;
	print "<td width=25% align=center><a href=\"$cgibinurl/abouttrack.cgi?$path.mp3\">$ttime</a></td>\n";
	print "</tr>\n";

	++$trknum;
    }
    while ($indent > 0) {
	if ($indent == 2) {
	    if ($albumicon ne "") {
		print "</table></td><td align=center><img src=\"$albumicon\"></td></tr></table>\n"
	    } else {
		print "</table></td><td align=center> &nbsp; </td></tr></table>\n"
	    }
	}
	if ($indent == 1) {
	    print "</ul>\n"
	}
	$indent--;
    }

    print "<table width=50%>\n";
    print "<tr><td></td>\n";
    print "<td align=right>\n";
    if ($navimage) {
	print "<img src=\"$topurl/$navblot\" border=0 usemap=\"#navmap\">\n";
    } else {
	print "<table>\n";
	print "<tr><td colspan=3 align=center><a href=\"#TOPOFILE\">\n";
	print "<img src=\"$topurl/upto.gif\" alt=\"topOfPage\" border=0></a></td></tr>\n";
	print "<tr><td align=center>";
	if ($previouspage > 0) {
	    print "<a href=\"$cgibinurl/dynindex.cgi?abn=$previouspage#ENDOFILE\"><img src=\"$topurl/upup.gif\" alt=\"previousPage Back\" border=0></a>\n";
	}
    #    if ($isprev) {
    #	print "<a href=\"tunesbyartist", $prevcb, ".html\"><img src=\"$topurl/upup.gif\" alt=\"browse Back\" border=0></a>\n";
    #    }
	print "</td>\n";
	print "<td align=center><a href=\"$cgibinurl/artists.cgi\"><img src=\"$topurl/ana.gif\" alt=\"to Index\" border=0></a></td>\n";
	print "<td align=center>";
	if ($nextpage > 0) {
	    print "<a href=\"$cgibinurl/dynindex.cgi?abn=$nextpage\"><img src=\"$topurl/downdown.gif\" alt=\"nextPage\" border=0></a>\n";
	}
	print "</td></tr>\n";
	print "<tr><td colspan=3 align=center><a href=\"#ENDOFILE\">\n";
	print "<img src=\"$topurl/downto.gif\" alt=\"bottomOfPage\" border=0></a></td></tr>\n";
	print "</table>\n";
    }
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
}

